Global tilezoom:Float = 1.0, tile:TImage = LoadAnimImage("etc/gfx/t.png", 140, 140, 0, 18)
SetImageHandle(tile,61,61)
Type Titem
	Field i:Int, j:Int
	Field x3D:Float[9], y3D:Float[9], z3D:Float
	Field x2D:Float[9], y2D:Float[9]
	Field housetop_index:Int, halfwidth:Int, halfheight:Int, depth:Int, tile_index:Byte
	'------------------------------------------------------
	Function build:Titem(i%, j%, middle_x3D#, middle_y3D#, halfwidth%, halfheight%, depth#)
		Local NewItem:Titem = New Titem
		NewItem.i = i
		NewItem.j = j
		NewItem.halfwidth = halfwidth
		NewItem.halfheight = halfheight
		NewItem.depth = depth
		NewItem.x3D = [middle_x3D-halfwidth, middle_x3D-halfwidth, middle_x3D+halfwidth, middle_x3D+halfwidth, middle_x3D-halfwidth, middle_x3D-halfwidth, middle_x3D+halfwidth, middle_x3D+halfwidth, middle_x3D]
		NewItem.y3D = [middle_y3D-halfheight, middle_y3D+halfheight, middle_y3D+halfheight, middle_y3D-halfheight, middle_y3D-halfheight, middle_y3D+halfheight, middle_y3D+halfheight, middle_y3D-halfheight, middle_y3D]
		NewItem.z3D = Ground_z3D-depth
		NewItem.convert_3D_to_2D()
		NewItem.housetop_index = Byte(Rand(0,9))
		NewItem.tile_index = Byte(Rand(0,13))
		If Rand(0,2) > 0 Then '33 % skyscrapers
			NewItem.tile_index = Byte(Rand(0,17))
			NewItem.housetop_index = -1
		End If
		'----------------------------------
		Return NewItem
	End Function
	'------------------------------------------------------------------------------
	Method convert_3D_to_2D()
		For Local i% = 0 To 3
			x2D[i] = CentralX + (x3D[i] - CentralX) / (1.001^z3D)
			y2D[i] = CentralY + (y3D[i] - CentralY) / (1.001^z3D)
		Next
		For Local i% = 4 To 8
			x2D[i] = CentralX + (x3D[i] - CentralX) / (1.001^Ground_z3D)
			y2D[i] = CentralY + (y3D[i] - CentralY) / (1.001^Ground_z3D)
		Next
	End Method
	'------------------------------------------------------------------------------
	Method draw()
		SetScale 0.5*tilezoom, 0.5*tilezoom
		'_____________________________
		If housetop_index = -1 Then Return
		'_____________________________
		SetScale 1,1
		If x2D[0] > CentralX Then
			draw_housefront([x2D[0], y2D[0], x2D[4], y2D[4], x2D[5], y2D[5], x2D[1], y2D[1]])
		ElseIf x2D[3] < CentralX Then
			draw_housefront([x2D[2], y2D[2], x2D[6], y2D[6], x2D[7], y2D[7], x2D[3], y2D[3]])
		End If
		If y2D[0] > CentralY Then
			draw_housefront([x2D[3], y2D[3], x2D[7], y2D[7], x2D[4], y2D[4], x2D[0], y2D[0]])
		ElseIf y2D[1] < CentralY
			draw_housefront([x2D[1], y2D[1], x2D[5], y2D[5], x2D[6], y2D[6], x2D[2], y2D[2]])
		End If
		SetRotation 0
		SetScale (x2D[3]-x2D[0]) / housetop_size, (y2D[1]-y2D[0]) / housetop_size
		DrawImage housetop, x2D[0], y2D[0], housetop_index
		SetScale 1,1
	End Method
	'------------------------------------------
	Method move_center_item(x3D_addition#, y3D_addition#, z3D_addition# = 0)
		'Nicht nur die Hoehe, auch die Perspektive soll sich zwischenzeitlich aendern...
		If z3D_addition > 0 Then
			If Ground_z3D < 200 Then
				CentralY = CentralY + 0.5*Sin(180*((Ground_z3D+1000)/1200.0))
				Ground_z3D = Ground_z3D + z3D_addition
				z3D = z3D + z3D_addition
				HeliScale = HeliScale + 0.0015
				Control_z_angle = -157+134 * (Ground_z3D + 1000) / 1200.0
				Real_wind_Power_x = Wind_Power_x * HeliScale 'abhaengig von Flughoehe
				Real_wind_Power_y = Wind_Power_y * HeliScale
				Wind_PowerInfo = Left(String(7.45*Sqr(Real_Wind_Power_x*Real_Wind_Power_x + Real_Wind_Power_y*Real_Wind_Power_y)), 3)
				Absolute_Moving_x = -Fly_Speed_change * Sin(Fly_Direction) + Real_Wind_Power_x
				Absolute_Moving_y = Fly_Speed_change * Cos(Fly_Direction) + Real_Wind_Power_y
				Absolute_Fly_Direction_change = Sqr(Absolute_Moving_x*Absolute_Moving_x + Absolute_Moving_y*Absolute_Moving_y)
				Control_Speed_angle = -157+34 * Absolute_Fly_Direction_change
			End If
		ElseIf z3D_addition < 0 Then
			If Ground_z3D > -1000 Then
				CentralY = CentralY - 0.5*Sin(180*((Ground_z3D+1000)/1200.0))
				Ground_z3D = Ground_z3D + z3D_addition
				z3D = z3D + z3D_addition
				HeliScale = HeliScale - 0.0015
				Control_z_angle = -157+134 * (Ground_z3D + 1000) / 1200.0
				Real_wind_Power_x = Wind_Power_x * HeliScale
				Real_wind_Power_y = Wind_Power_y * HeliScale
				Wind_PowerInfo = Left(String(7.45*Sqr(Real_Wind_Power_x*Real_Wind_Power_x + Real_Wind_Power_y*Real_Wind_Power_y)), 3)
				Absolute_Moving_x = -Fly_Speed_change * Sin(Fly_Direction) + Real_Wind_Power_x
				Absolute_Moving_y = Fly_Speed_change * Cos(Fly_Direction) + Real_Wind_Power_y
				Absolute_Fly_Direction_change = Sqr(Absolute_Moving_x*Absolute_Moving_x + Absolute_Moving_y*Absolute_Moving_y)
				Control_Speed_angle = -157+34 * Absolute_Fly_Direction_change
			End If
		End If
		For Local i% = 0 To 3
			x3D[i] = x3D[i] + x3D_addition
			y3D[i] = y3D[i] + y3D_addition
			x2D[i] = CentralX + (x3D[i] - CentralX) / (1.001^z3D)
			y2D[i] = CentralY + (y3D[i] - CentralY) / (1.001^z3D)
		Next
		For Local i% = 4 To 8
			x3D[i] = x3D[i] + x3D_addition
			y3D[i] = y3D[i] + y3D_addition
			x2D[i] = CentralX + (x3D[i] - CentralX) / (1.001^Ground_z3D)
			y2D[i] = CentralY + (y3D[i] - CentralY) / (1.001^Ground_z3D)
		Next
		tilezoom = 0.5 * (x2D[7]-x2D[4]) / halfwidth
		SetScale tilezoom, tilezoom
		SetRotation 0
		DrawImage tile, x2D[8], y2D[8], tile_index
	End Method
	'------------------------------------------
	Method move_other_item()
		x3D[8] = item[center_item_i, center_item_j].x3D[8] - (center_item_i - i) * items_distance
		x3D[0] = x3D[8]-halfwidth
		x3D[1] = x3D[0]
		x3D[2] = x3D[8]+halfwidth
		x3D[3] = x3D[2]
		x3D[4] = x3D[0]
		x3D[5] = x3D[0]
		x3D[6] = x3D[2]
		x3D[7] = x3D[2]
		'---------------------
		y3D[8] = item[center_item_i, center_item_j].y3D[8] - (center_item_j - j) * items_distance
		y3D[0] = y3D[8]-halfheight
		y3D[1] = y3D[8]+halfheight
		y3D[2] = y3D[1]
		y3D[3] = y3D[0]
		y3D[4] = y3D[0]
		y3D[5] = y3D[1]
		y3D[6] = y3D[1]
		y3D[7] = y3D[0]
		'---------------------
		z3D = -depth + item[center_item_i, center_item_j].depth + item[center_item_i, center_item_j].z3D
		convert_3D_to_2D()
		DrawImage tile, x2D[8], y2D[8], tile_index
	'------------------------------------------
	End Method
End Type
